* ECBASIC 

HIGHVAL EQU 1     ;PUT SYMBOL TABLE IN HIGH LOGICAL MEMORY
ECHO EQU 0        ;ECHO SOURCE WHILE INPUTING
XLATEVAL EQU 1    ;TRANSLATE SOURCE WHILE LISTING
SAVEBIN EQU 0     ;SAVE BINARY FIL

MMU EQU $20       ;FIRST PHYSICAL MMU IN MACHINE SPACE

 SETDP 0
 
DIFF EQU $8000

TXTTAB EQU $19
VARTAB EQU $1B
FRETOP EQU $21
MEMSIZ EQU $27
FPA0 EQU $50
CURLIN EQU $68
GETNCH EQU $9F
LBUFMX EQU $0FA
RVEC17 EQU $191 ; ERROR
RVEC23 EQU $1A3 ; CRUNCH
RVEC24 EQU $1A6 ; UNCRUNCH
LINHDR EQU $2DA
LINBUF EQU $2DC
CHARAD EQU $0A6
ERROR EQU $0AC4C
FIX EQU $0ACE9
DIRECTLOOP EQU $0AC7C
INITIALIZE EQU $0AD21
GOTOSUB EQU $0AE88
GIVABF EQU $0B4F4
EVALEXPR EQU $0B70B
CRUNCH EQU $0B824
GOTOKEN EQU 129
REMTOKEN EQU 130
QUOTOKEN EQU 131
DATATOKEN EQU 134
ONTOKEN EQU 136
TOTOKEN EQU 165
SUBTOKEN EQU 166
EQTOKEN EQU 179

TEXT EQU $2000

 ORG $1F80
 JMP PREPARE7
 JMP PREPARE8
 JMP PREPARE9
 
IN6 LDA #MMU
IN7 STA $FFA1
 INCA
 STA $FFA2
 INCA 
 STA $FFA3
 RTS

PREPARE7 LDA #$39
 BRA IN7

PREPARE8 LDD #LAST
 ANDA #$7F
 JSR GIVABF 
 LDA #MMU+3
 STA $FFA3
 RTS

PREPARE9 LDA #$3B
 STA $FFA3
 RTS
 
LOF EQU *

 ORG $7E80
 
HIGHMEM FCB HIGHVAL ;PUT SYMBOL TABLE IN HIGH LOGICAL MEMORY
 FCB ECHO ; ECHO INPUT LINES
SAVE FCB SAVEBIN
 JMP PREPARE0
 JMP PREPARE1
 JMP PREPARE2
 JMP PREPARE3
 JMP PREPARE4
 JMP PREPARE5
 JMP PREPARE6

VALUES EQU *
POINT FDB TEXT
VARIABLES FDB $5000
VAREND FDB $5000
NEWSTACK FDB $5000
TEXTEND FDB $4F80

PREPARE3 LDD POINT
 JSR GIVABF
 RTS

PREPARE4 LDD #TEMP
 JSR GIVABF
 RTS

PREPARE5 LDD #$5000
 TST HIGHMEM
 BEQ LOVAR
 LDD #$2000
LOVAR JSR GIVABF
 RTS

PREPARE6 LDD VAREND
 TST HIGHMEM
 BEQ LOVAREND
 ANDA #$7F
 ADDD #$2000
 JSR GIVABF
 JMP IN6
LOVAREND JSR GIVABF 
 RTS
 
PREPARE0 JSR MACHINE ;START
 JSR START+DIFF
 JSR BASIC
 RTS
PREPARE1 LDU CHARAD
 PSHS U
 LDX 2,X
 STX CHARAD
 JSR CRUNCH
 JSR MACHINE
 LDX #LINBUF
 LDU POINT
 LBSR USR1+DIFF
 STU POINT
 PULS U
 STU CHARAD
 JSR BASIC
 RTS
PREPARE2 LDD #TEMP2
 JSR GIVABF
 RTS
TEMP2 JSR MACHINE
 JSR ZIN+DIFF
 LBSR USR2+DIFF
 JSR BASIC
 JSR INITIALIZE
JUMP JMP DIRECTLOOP

BASIC PSHS A
 LDA #$3C
 BRA BASICIN
MACHINE ORCC #$50
 PSHS A
 LDA #$2C
BASICIN STA $0FFA4
 INCA
 STA $0FFA5
 INCA
 STA $0FFA6
 INCA
 STA $0FFA7
 PULS A,PC

PREPARE17 CMPB #1*2 ; SN
 BEQ HOOKIN17
 CMPB #2*7 ; UL
 BNE RETURN17
HOOKIN17 JSR MACHINE
 LBSR HOOK17+DIFF
 JSR BASIC
 CMPB #1
 BEQ UL2GO17
 CMPB #3
 BEQ ON2SN17
 CMPB #5 ; ON FALL THRE
 BNE RETURN17
 JSR GETNCH
 LEAS 2,S ; ON FALL THRU 
UL2GO17 LEAS 2,S
RETURN RTS

EVAL17 JSR BASIC
 JSR EVALEXPR
 JSR MACHINE
 RTS
 
ON2SN17 LDB #2
RETURN17 FCB 0
 FDB 0
 
TOSUB17 JSR BASIC
 LEAS 6,S
 JMP GOTOSUB

PREPARE23 LDX ,S++
 LDU #HOOK23
 PSHS U,X
RETURN23 FCB 0
 FDB 0
HOOK23 JSR MACHINE
 LBSR HOOK1+DIFF
 JSR BASIC
 RTS

PREPARE24 JSR MACHINE
 LBSR HOOK24+DIFF
 JSR BASIC
RETURN24 FCB 0
 FDB 0

TEMP EQU *

 ORG $7FFF
 FCB $12

 ORG $0FFA3
 FCB $2F

 ORG $6000

TRANSLATE FCB XLATEVAL ;UNCRUNCH LISTINGS
LOVALUES EQU *
 FDB $2000 ;POINT
 FDB $5000 ;VARIABLES
 FDB $5000 ;VAREND
 FDB $5000 ;NEWSTACK
 FDB $4F80 ;TEXTEND
HIVALUES EQU *
 FDB $2000 ;POINT
 FDB $8000 ;VARIABLES
 FDB $8000 ;VAREND
 FDB $7E80 ;NEWSTACK
 FDB $7E00 ;TEXTEND
PREFIX FCC /AA/
LENGTH FCB 0
WHERE FDB 0
LINUM FDB 0
INDEX FDB 0
MEMORY FCB 0
LONGLINE FCB 0
FLAG FCB 0

TABLE FCB 0  ;PREAMBLE FLAG
 FDB 1       ;LENGTH
 FDB $FFA3 ;LOAD ADDRESS
*MMU FCB $2B  ;DATA
PRE FCB 0      ;PREAMBLE FLAG
LEN FDB $2000  ;LENGTH
LOAD FDB $2000 ;LOAD ADDRESS

* BYTE PREAMBLE             POSTAMBLE
* 0    00 Preamble flag     $FF Post-amble flag
* 1,2  Length of data block Two zero bytes
* 3,4  Load address         EXEC address

TABLEA FDB TABLE
 FDB 11

*USR3 TST HIGHMEM
 LBEQ RTS3
 TST SAVE
 LBEQ RTS3
 LDA #$2B
* STA MMU+DIFF
 LDA #0
 STA FLAG+DIFF
 LDX #TABLE+DIFF
* INC MMU+DIFF
 
 LDD VAREND
 SUBD #$2000
* BLS DONE
 STA ,X+
 LDD POINT
 STD ,X++
 SUBD #TEXT
 STD ,X++
 LDD #TEXT
 STD ,X++
 STD ,X++
 LDD VARIABLES
 LDU #$2000
MORE3 FCB 0
 FDB 1
 FDB $FFA3
 STD 5,X
 CLR ,X+
 STU ,X++
 STU ,X++
 LEAX 2,X
 SUBD VAREND
 CMPD #$2000
 BHI MORE3
 CLR ,X+
 STD ,X++
 STU ,X++
 LEAX 2,X
 RTS

START LDB #10
 LDU #VALUES
 LDX #LOVALUES+DIFF
 TST HIGHMEM
 BEQ LOWMEM0
 LDX #HIVALUES+DIFF
LOWMEM0 LDA ,X+
 STA ,U+
 DECB
 BNE LOWMEM0
 LDX #0
 STX LINUM+DIFF
 STX INDEX+DIFF
 CLR MEMORY+DIFF
 CLR LONGLINE+DIFF
 LDA #'A
 STA PREFIX+DIFF
 STA PREFIX+1+DIFF
 LDX VARIABLES
 CLR ,X
 STX VAREND
 LDX #TEXT
 STX POINT
 RTS
 
ZIN LDA RVEC17
 LDX RVEC17+1
 CMPX #PREPARE17
 BEQ RTS1
 STA RETURN17
 STX RETURN17+1
 LDA JUMP
 LDX #PREPARE17
 STA RVEC17
 STX RVEC17+1
 LDA RVEC23
 LDX RVEC23+1
 STA RETURN23
 STX RETURN23+1
 LDA JUMP
 LDX #PREPARE23
 STA RVEC23
 STX RVEC23+1
 LDA RVEC24
 LDX RVEC24+1
 STA RETURN24
 STX RETURN24+1
 LDA JUMP
 LDX #PREPARE24
 STA RVEC24
 STX RVEC24+1
RTS RTS

WHERE1 FDB 0
LETTERS1 FDB 0
NAME1 FDB 0
GOAL1 FDB 0
OUTFLAG1 FCB 0
MOVEND1 STX GOAL1+DIFF
END1 TST ,X+
 BNE END1
 LDU #LINBUF+LBUFMX
MOVE1 LDA ,-X
 STA ,-U
 CMPX GOAL1+DIFF
 BHI MOVE1
 TFR U,X
 RTS
HOOK24 TST TRANSLATE+DIFF
 BEQ RTS1
 LDA #1
 STA OUTFLAG1+DIFF
 LEAX 4,X
 BSR MOVEND1
 LDU #LINBUF
 BSR LABEL1
 LDX #LINBUF
 BSR MOVEND1
 LEAX -4,U
RTS1 RTS 
LABEL1 LDA ,X+
 CMPA #'Z
 BNE OUT1
 CMPA ,X
 BNE OUT1
 LEAX 2,X
 LDA ,X+
OUT1 CMPA #'A
 BLO NOVAR1
 CMPA #'Z
 BHI NOVAR1
 LDB ,X
 CMPB #'0
 BLO SINGVAR1
 CMPB #'9
 BLS YESVAR1
 CMPB #'A
 BLO SINGVAR1
 CMPB #'Z
 BLS YESVAR1
SINGVAR1 STX WHERE1+DIFF
 ADDA #'a-'A
 STA ,U+
 BRA ATIN1
YESVAR1 LEAX 1,X
 STX WHERE1+DIFF
 TFR D,X
 LDA #13
 LDY VARIABLES
FINDLOOP1 STY NAME1+DIFF
 TST ,Y
 BNE FIND1
 LDA #'@
 STA ,U+
 STX ,U++
 BRA ATIN1
FIND1 CMPA ,Y+
 BNE FIND1
 CMPX ,Y++
 BNE FINDLOOP1
 LDX NAME1+DIFF
NAMEOUT1 LDB ,X+
 STB ,U+
 CMPA ,X
 BNE NAMEOUT1
ATIN1 LDX WHERE1+DIFF
 LDA ,X+
NOVAR1 CMPA #'!
 LBNE NOTON1
 LDA ,X+
 CMPA #ONTOKEN
 BEQ ON1
 LDA #'!
 STA ,U+
ON1 LDA -1,X
 LBRA NOTON1
HOOK1 CLR OUTFLAG1+DIFF
 LDX #LINBUF
 LBSR MOVEND1
 LDU #LINBUF
 BSR USR1
 CLR ,U+
 CLR ,U+
 TFR U,D
 SUBD #LINHDR
 LDX #LINBUF-1
 STX CHARAD
 RTS
ADRES1 FDB 0
ADRES2 FDB 0
USR1 CLR OUTFLAG1+DIFF
 STX ADRES2+DIFF
SPACE1 LDA ,X+
 CMPA #$20
 BEQ SPACE1
 STX ADRES1+DIFF
 CMPA #'a
 BLO RESET1
 CMPA #'z
 BHI RESET1
LONG1 LDA ,X+
 CMPA #'0
 BLO MAYBE1
 CMPA #'9
 BLS LONG1
 CMPA #'a
 BLO MAYBE1
 CMPA #'z
 BLS LONG1
MAYBE1 TSTA
 BEQ RESET1
 CMPA #$20
 BNE COLON1
 LDA ,X+
 BRA MAYBE1
COLON1  CMPA #':
 BNE RESET1
 STX ADRES2+DIFF
 LDA #'Z
 STA ,U+
 STA ,U+
 LDA #EQTOKEN
 STA ,U+
 LDX ADRES1+DIFF
 LDA -1,X
 LBSR VARIABLE
 STA ,U+
 LDA #':
 STA ,U+
RESET1 LDX ADRES2+DIFF
LOOP1 LDA ,X+
 TST OUTFLAG1+DIFF
 LBNE OUT1
 LDB -2,X
 CMPA #ONTOKEN
 BNE NOTON1
 LDB -2,X
 CMPB #$FF
 BEQ NOTON1
 LDB #'!
 STB ,U+
 STA ,U+
 LDA ,X+
NOTON1 CMPA #'"
 BNE NOTDBLQ1
DBLQ1 STA ,U+
 LDA ,X+
 BEQ EXIT1
 CMPA #'"
 BNE DBLQ1
 STA ,U+
 LDA ,X+
NOTDBLQ1 CMPA #REMTOKEN
 BNE NOTREM1
 LDB -2,X
 CMPB #$FF
 BEQ QUOTE1
NOTREM1 CMPA #DATATOKEN
 BNE NOTDATA1
 LDB -2,X
 CMPB #$FF
 BNE QUOTE1
NOTDATA1 CMPA #':
 BNE NOTQUOTE1
 LDB ,X
 CMPB #QUOTOKEN
 BNE NOTQUOTE1
QUOTE1 STA ,U+
 LDA ,X+
 BNE QUOTE1 
 BRA EXIT1
NOTQUOTE1 CMPA #'&
 BNE NOTHEX1
 LDB ,X
 CMPB #'H
 BEQ HEXAND1
 CMPB #'h
 BNE NOTHEX1
 LDB #'H 
HEXAND1 STA ,U+
 LEAX 1,X
HEX1 STB ,U+
 LDB ,X+
 CMPB #'0
 BLO HEXEXIT1
 CMPB #'9
 BLS HEX1
 CMPB #'A
 BLO HEXEXIT1
 CMPB #'F
 BLS HEX1
HEXEXIT1 LDA -1,X
 BRA EXIT1	
NOTHEX1 CMPA #'a
 BLO EXIT1
 CMPA #'z
 BHI EXIT1
 LBSR VARIABLE
EXIT1 STA ,U+
 LBNE LOOP1
 RTS

USR2 LDX ,S
 LDS NEWSTACK
 STS MEMSIZ
 LEAU -200,S
 STU FRETOP
 STX ,--S
 LDX POINT
 LDU TEXTEND
 CLR ,-U
 BRA COPYIN2
COPY2 LDA ,-X
 STA ,-U
COPYIN2 CMPX #TEXT
 BHI COPY2
 LDX TXTTAB
 STX VARTAB
 LDY #0
 BRA MOVEIN2
MOVELINE2 STX VARTAB 
 CLR ,X+
 CLR ,X+
 LEAY 1,Y
 STY ,X++
MOVECHAR2 STA ,X+
 LDA ,U+
 BNE MOVECHAR2
 STA ,X+
 STX [VARTAB]
MOVEIN2 LDA ,U+
 BNE MOVELINE2
 CLR ,X+
 CLR ,X+
 STX VARTAB
RTS3 RTS

FLAG3 FCB 0
HOOK17 CMPB #2*7 ; UL ENTRY
 BEQ UL3
 CMPB #2*1 ; SN ENTRY
 BNE RTS3
 LDX CHARAD
 LDA ,X
 CMPA #'!
 BNE RTS3
 LDA 1,X
 CMPA #ONTOKEN
 BNE RTS3
 LEAX 2,X
 LDA ,X
 STX CHARAD
 JSR EVAL17
 LDX CHARAD
 LDD ,X++
 CMPA #GOTOKEN
 LBNE ON2SN3
 CMPB #TOTOKEN
 BEQ LOOP3
 CMPB #SUBTOKEN
 BEQ LOOP3
ON2SN3 LDB #3 ; SN FROM SN ENTRY
 RTS
LOOP3 DEC FPA0+3
 BNE ALPHVAL3
TOSUB3 LEAX -1,X
 STX CHARAD
 JMP TOSUB17
ALPHVAL3 LDA ,X+
 CMPA #$20
 BEQ ALPHVAL3
 CMPA #'A
 BLO SING3
 CMPA #'Z
 BHI SING3
 LDA ,X
 CMPA #'0
 BLO SING3
 CMPA #'9
 BLS DOUB3
 CMPA #'A
 BLO SING3
 CMPA #'Z
 BHI SING3
DOUB3 LEAX 1,X
SING3 LDA ,X+
 CMPA #$20
 BEQ SING3
 CMPA #',
 BEQ LOOP3
 LEAX -2,X
 STX CHARAD
 LDB #5 ; FALL THRU FROM SN ENTRY
 RTS 
UL3 LDA #'Z
 LDB #'Z
 TFR D,U
 CLR FLAG3+DIFF
 INC FLAG3+DIFF
 LDX CHARAD
SPACE3 LDA ,X+
 CMPA #$20
 BEQ SPACE3
 LDB ,X
 CMPA #'A
 BLO UL2UL
 CMPA #'Z
 BHI UL2UL
 CMPB #'0
 BLO SINGLE3
 CMPB #'9
 BLS DOUBLE3
 CMPB #'A
 BLO SINGLE3
 CMPB #'Z
 BLS DOUBLE3
SINGLE3 LDB #':
DOUBLE3 TST ,X+
 BNE DOUBLE3
 BRA DOWNIN3
DOWN3 LDX ,X
 BEQ BOTTOM3
DOWNIN3 CMPD 7,X
 BNE DOWN3
 CMPU 4,X
 BNE DOWN3
 LEAX -1,X
 STX CHARAD
 LDB #1 ; GOOD RETURN FROM UL
 RTS
BOTTOM3 LDX TXTTAB
 DEC FLAG3+DIFF
 BEQ DOWNIN3
UL2UL LDB #7*2 ; UL FROM UL ENTRY
 RTS

ALPHVAL LDA ,X+
 CMPA #$20
 BEQ ALPHVAL
 CMPA #'A
 BLO AVEMPTY
 CMPA #'Z
 BHI AVEMPTY
 LDB ,X+
 CMPB #'0
 BLO AVSINGLE
 CMPB #'9
 BLS AVDOUBLE
 CMPB #'A
 BLO AVSINGLE
 CMPB #'Z
 BLS AVDOUBLE
AVSINGLE LDB #':
 LEAX -1,X
 RTS
AVEMPTY CLRB
AVDOUBLE RTS

VARIABLE STX WHERE+DIFF
 CLRB
VARLEN LDA ,X+
 INCB
 CMPA #'0
 BLO TESTONE
 CMPA #'9
 BLS VARLEN
 CMPA #'A
 BLO TESTONE
 CMPA #'Z
 BLS VARLEN
 CMPA #'a
 BLO TESTONE
 CMPA #'z
 BLS VARLEN
TESTONE CMPB #1
 BNE MORE
 LDA -2,X
 ADDA #'Z-'z
 LEAX -1,X
 RTS
MORE PSHS U
 LDX WHERE+DIFF
 LEAX -1,X
 STX WHERE+DIFF
 STB LENGTH+DIFF
 LDU VARIABLES
 BRA LOOPIN
LOOP CMPA ,X+
 BNE SKIPIN
 LDA ,U+
 CMPA #$D
 BNE NOTFOUND
 CMPB #1
 BEQ FOUND
NOTFOUND DECB
 BNE LOOP
SKIP LDA ,U+
SKIPIN CMPA #$D
 BNE SKIP
 LEAU 2,U
 LDB LENGTH+DIFF
 LDX WHERE+DIFF
LOOPIN LDA ,U+
 BNE LOOP
 LEAU -1,U
NEW LDA ,X+
 STA ,U+
 DECB
 BNE NEW
 LDA #13
 STA ,U+
 LDD PREFIX+DIFF
 STD ,U++
 CMPB #'Z
 BLO NEWPRE
 INCA
 LDB #'A-1
NEWPRE INCB
 STD PREFIX+DIFF
 CLR ,U
 STU VAREND
 LEAU -2,U
FOUND LDX WHERE+DIFF
 LDB LENGTH+DIFF
 LEAX B,X
 LDD ,U
 PULS U
 STA ,U+
 TFR B,A
 RTS

LAST EQU *
 
 ORG $0FFA3
 FCB $3B
 
 END PREPARE0
 